Name:           AutoScan
Summary:        Utility for network exploration (Samba,Nessus client).
Version:        0.99_R1
Release:        0
Source0:        %{name}.%{version}.tar.gz
URL:            http://autoscan.free.fr
Group:		Networking/Other
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot 
License:        GNU General Public License (GPL)
BuildRequires:  libxml2-devel
BuildRequires:  glib-devel
BuildRequires:  gtk2-devel
BuildRequires:  libao-devel
BuildRequires:  libvorbis-devel
BuildRequires:  libgnomeui-devel
BuildRequires:  vte-devel
BuildRequires:  net-snmp-devel
Requires:       samba-client


%description
AutoScan is an application designed to explore and to manage your network. Entire subnets can be scanned simultaneously without human intervention. It features OS detection, automatic network discovery, a port scanner, a Samba share browser, and the ability to save the network state.

%prep  
%setup -q -a 0

%build
./configure
make

%install
rm -rf %{buildroot}
install -d %{buildroot}/usr/share/doc/AutoScan/
install -d %{buildroot}/usr/share/pixmaps/AutoScan/
install -d %{buildroot}/usr/share/apps/AutoScan/
install -d %{buildroot}/usr/lib/menu/
install -d %{buildroot}/bin/
install -d %{buildroot}/usr/share/icons/
install -d %{buildroot}/usr/share/sounds/AutoScan/
install -d %{buildroot}/usr/share/applications/

cd bin/
install -m755 AutoScan_Network %{buildroot}/bin/
install -m755 AutoScan_Agent %{buildroot}/bin/
cd ..
cp -R usr/* %{buildroot}/usr/

%clean
rm -rf %{buildroot}


%post
update-desktop-database %{_datadir}/applications
export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
SCHEMAS="AutoScan.schemas"
for S in $SCHEMAS; do
  gconftool-2 --makefile-install-rule /usr/share/apps/AutoScan/$S > /dev/null
done
chmod +s /bin/AutoScan_Agent


%postun
update-desktop-database %{_datadir}/applications

%files
%defattr(755,root,root)
   /bin/*
   /usr/share/apps/AutoScan/*
   /usr/share/doc/AutoScan/*
   /usr/share/pixmaps/AutoScan/*
   /usr/share/icons/*
   /usr/share/sounds/AutoScan/*  
   /usr/share/applications/*
%defattr(644,root,root)
   /usr/lib/menu/

%changelog
* Fri Aug 25 2006 Thierry Lagarde<tlagarde@users.sourceforge.net>
 - update to 0.99

%changelog
* Tue Mar 28 2006 Thierry Lagarde<tlagarde@users.sourceforge.net>
 - update to 0.99

* Wed Jan 25 2006 Thierry Lagarde<tlagarde@users.sourceforge.net>
 - initial build 
